diff --git a/drivers/net/virtio/virtio_ethdev.c b/drivers/net/virtio/virtio_ethdev.c
index 9ca8bae0fe..d722fbe04a 100644
--- a/drivers/net/virtio/virtio_ethdev.c
+++ b/drivers/net/virtio/virtio_ethdev.c
@@ -212,7 +212,7 @@ virtio_send_command_packed(struct virtnet_ctl *cvq,
 			"vq->vq_avail_idx=%d\n"
 			"vq->vq_used_cons_idx=%d\n"
 			"vq->vq_packed.cached_flags=0x%x\n"
-			"vq->vq_packed.used_wrap_counter=%d\n",
+			"vq->vq_packed.used_wrap_counter=%d",
 			vq->vq_free_cnt,
 			vq->vq_avail_idx,
 			vq->vq_used_cons_idx,
diff --git a/drivers/net/virtio/virtio_pci.c b/drivers/net/virtio/virtio_pci.c
index c14d1339c9..182cfc9eae 100644
--- a/drivers/net/virtio/virtio_pci.c
+++ b/drivers/net/virtio/virtio_pci.c
@@ -410,7 +410,7 @@ static int
 modern_features_ok(struct virtio_hw *hw)
 {
 	if (!virtio_with_feature(hw, VIRTIO_F_VERSION_1)) {
-		PMD_INIT_LOG(ERR, "Version 1+ required with modern devices\n");
+		PMD_INIT_LOG(ERR, "Version 1+ required with modern devices");
 		return -1;
 	}
 
diff --git a/drivers/net/virtio/virtio_pci_ethdev.c b/drivers/net/virtio/virtio_pci_ethdev.c
index 4083853c48..54645dc62e 100644
--- a/drivers/net/virtio/virtio_pci_ethdev.c
+++ b/drivers/net/virtio/virtio_pci_ethdev.c
@@ -81,7 +81,7 @@ eth_virtio_pci_init(struct rte_eth_dev *eth_dev)
 		VTPCI_DEV(hw) = pci_dev;
 		ret = vtpci_init(RTE_ETH_DEV_TO_PCI(eth_dev), dev);
 		if (ret) {
-			PMD_INIT_LOG(ERR, "Failed to init PCI device\n");
+			PMD_INIT_LOG(ERR, "Failed to init PCI device");
 			return -1;
 		}
 	} else {
@@ -93,14 +93,14 @@ eth_virtio_pci_init(struct rte_eth_dev *eth_dev)
 
 		ret = virtio_remap_pci(RTE_ETH_DEV_TO_PCI(eth_dev), dev);
 		if (ret < 0) {
-			PMD_INIT_LOG(ERR, "Failed to remap PCI device\n");
+			PMD_INIT_LOG(ERR, "Failed to remap PCI device");
 			return -1;
 		}
 	}
 
 	ret = eth_virtio_dev_init(eth_dev);
 	if (ret < 0) {
-		PMD_INIT_LOG(ERR, "Failed to init virtio device\n");
+		PMD_INIT_LOG(ERR, "Failed to init virtio device");
 		goto err_unmap;
 	}
 
diff --git a/drivers/net/virtio/virtio_user/virtio_user_dev.c b/drivers/net/virtio/virtio_user/virtio_user_dev.c
index 16c58710d7..200942d622 100644
--- a/drivers/net/virtio/virtio_user/virtio_user_dev.c
+++ b/drivers/net/virtio/virtio_user/virtio_user_dev.c
@@ -44,7 +44,7 @@ virtio_user_create_queue(struct virtio_user_dev *dev, uint32_t queue_sel)
 	file.fd = dev->callfds[queue_sel];
 	ret = dev->ops->set_vring_call(dev, &file);
 	if (ret < 0) {
-		PMD_INIT_LOG(ERR, "(%s) Failed to create queue %u\n", dev->path, queue_sel);
+		PMD_INIT_LOG(ERR, "(%s) Failed to create queue %u", dev->path, queue_sel);
 		return -1;
 	}
 
@@ -108,7 +108,7 @@ virtio_user_kick_queue(struct virtio_user_dev *dev, uint32_t queue_sel)
 
 	return 0;
 err:
-	PMD_INIT_LOG(ERR, "(%s) Failed to kick queue %u\n", dev->path, queue_sel);
+	PMD_INIT_LOG(ERR, "(%s) Failed to kick queue %u", dev->path, queue_sel);
 
 	return -1;
 }
@@ -214,7 +214,7 @@ virtio_user_start_device(struct virtio_user_dev *dev)
 	pthread_mutex_unlock(&dev->mutex);
 	rte_mcfg_mem_read_unlock();
 
-	PMD_INIT_LOG(ERR, "(%s) Failed to start device\n", dev->path);
+	PMD_INIT_LOG(ERR, "(%s) Failed to start device", dev->path);
 
 	/* TODO: free resource here or caller to check */
 	return -1;
@@ -255,7 +255,7 @@ int virtio_user_stop_device(struct virtio_user_dev *dev)
 err:
 	pthread_mutex_unlock(&dev->mutex);
 
-	PMD_INIT_LOG(ERR, "(%s) Failed to stop device\n", dev->path);
+	PMD_INIT_LOG(ERR, "(%s) Failed to stop device", dev->path);
 
 	return -1;
 }
@@ -500,17 +500,17 @@ virtio_user_dev_setup(struct virtio_user_dev *dev)
 	}
 
 	if (dev->ops->setup(dev) < 0) {
-		PMD_INIT_LOG(ERR, "(%s) Failed to setup backend\n", dev->path);
+		PMD_INIT_LOG(ERR, "(%s) Failed to setup backend", dev->path);
 		return -1;
 	}
 
 	if (virtio_user_dev_init_notify(dev) < 0) {
-		PMD_INIT_LOG(ERR, "(%s) Failed to init notifiers\n", dev->path);
+		PMD_INIT_LOG(ERR, "(%s) Failed to init notifiers", dev->path);
 		goto destroy;
 	}
 
 	if (virtio_user_fill_intr_handle(dev) < 0) {
-		PMD_INIT_LOG(ERR, "(%s) Failed to init interrupt handler\n", dev->path);
+		PMD_INIT_LOG(ERR, "(%s) Failed to init interrupt handler", dev->path);
 		goto uninit;
 	}
 
@@ -642,7 +642,7 @@ virtio_user_dev_init(struct virtio_user_dev *dev, char *path, int queues,
 	if (rte_mem_event_callback_register(VIRTIO_USER_MEM_EVENT_CLB_NAME,
 				virtio_user_mem_event_cb, dev)) {
 		if (rte_errno != ENOTSUP) {
-			PMD_INIT_LOG(ERR, "(%s) Failed to register mem event callback\n",
+			PMD_INIT_LOG(ERR, "(%s) Failed to register mem event callback",
 					dev->path);
 			return -1;
 		}
@@ -866,7 +866,7 @@ virtio_user_dev_set_status(struct virtio_user_dev *dev, uint8_t status)
 	dev->status = status;
 	ret = dev->ops->set_status(dev, status);
 	if (ret && ret != -ENOTSUP)
-		PMD_INIT_LOG(ERR, "(%s) Failed to set backend status\n", dev->path);
+		PMD_INIT_LOG(ERR, "(%s) Failed to set backend status", dev->path);
 
 	pthread_mutex_unlock(&dev->mutex);
 	return ret;
@@ -890,7 +890,7 @@ virtio_user_dev_update_status(struct virtio_user_dev *dev)
 			"\t-DRIVER_OK: %u\n"
 			"\t-FEATURES_OK: %u\n"
 			"\t-DEVICE_NEED_RESET: %u\n"
-			"\t-FAILED: %u\n",
+			"\t-FAILED: %u",
 			dev->status,
 			(dev->status == VIRTIO_CONFIG_STATUS_RESET),
 			!!(dev->status & VIRTIO_CONFIG_STATUS_ACK),
@@ -900,7 +900,7 @@ virtio_user_dev_update_status(struct virtio_user_dev *dev)
 			!!(dev->status & VIRTIO_CONFIG_STATUS_DEV_NEED_RESET),
 			!!(dev->status & VIRTIO_CONFIG_STATUS_FAILED));
 	} else if (ret != -ENOTSUP) {
-		PMD_INIT_LOG(ERR, "(%s) Failed to get backend status\n", dev->path);
+		PMD_INIT_LOG(ERR, "(%s) Failed to get backend status", dev->path);
 	}
 
 	pthread_mutex_unlock(&dev->mutex);
diff --git a/drivers/net/virtio/virtio_user_ethdev.c b/drivers/net/virtio/virtio_user_ethdev.c
index 90fcd6e7cc..688c1104d5 100644
--- a/drivers/net/virtio/virtio_user_ethdev.c
+++ b/drivers/net/virtio/virtio_user_ethdev.c
@@ -398,7 +398,7 @@ virtio_user_backend_type(const char *path)
 		if (errno == ENOENT)
 			return VIRTIO_USER_BACKEND_VHOST_USER;
 
-		PMD_INIT_LOG(ERR, "Stat fails: %s (%s)\n", path,
+		PMD_INIT_LOG(ERR, "Stat fails: %s (%s)", path,
 			     strerror(errno));
 		return VIRTIO_USER_BACKEND_UNKNOWN;
 	}